## Measurements

This report was generated with the measure-analysis.py script.
JSON formated measures were imported in the measures folder using the import functionnality of the script, this report was then generated using these measures.
Metadata is included with the measures, such as the kernel version used, the boot parameters passed, various others parameters specific to the measure, etc... 
Measures measuring the same propriety are grouped together in tables and graphs, and are identified by their diverging metadatas. This is useful to analyse the effect of specific parameters on the  measured propriety.

### Description of the metadata associated to each test

* **dev**: Device on which the tests were run
* **ker**: Linux kernel version used
* **prio**: Priority of the real-time thread
* **i**: Interval between each packet transmission
* **boot_p**: Boot Parameters passed to u-boot
* **delta**: ETF qdisc delta value
* **load**: External device and processor load during the test
* **duration**: Duration of the test
* **speed**: Ethernet speed in Mb/s
* **etf_offset**: When a packet\s txtime is scheduled, the txtime set is the current time offset by etf_offset
* **route**: How the boards are connected. switch means they are connected by a switch (cheap, unmanaged), E2E
* **qdisc**: qdisc used to send packets
* **client**: Device which sent the packets
* **XDP**: Were XDP sockets used
* **delay**: Callback schedule delay in us

### cyclictest_wake-up_latency results

Uses cyclictest from the rt-tests test suite to measure wake-up latency. A real-time thread is run on CPU1, and wakes up at a regular interval (specified by the interval parameter) using clock_nanosleep. It then uses clock_gettime and computes the difference between the scheduled wake-up time and the effective wake-up time measured by clock_gettime.
The command used is: cyclictest -p `prio` -a1 -t1 -n -h 200 -q -i `interval`

**Common test metadata:** Task priority: 98, Interval: 200us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, qdisc: pfifo_fast, Client device: A20, XDP: no

Metadata                         | Minimum             | Maximum             | Average             | Standard deviation  | Lost packets
-------------------------------- | ------------------- | ------------------- | ------------------- | ------------------- | ------------
**dev, ker, duration**           | **Wake-up latency** | **Wake-up latency** | **Wake-up latency** | **Wake-up latency** |             
Shuttle, 4.19, 16h35 (298524264) | 1.0000us            | 14.0000us           | 1.0082us            | 0.1107us            | 0           
A20, 5.6, 18h13 (328153384)      | 8.0000us            | 73.0000us           | 9.2684us            | 1.4574us            | 0           

![alt text](measures/graphs/cyclictest_wake-up_latencyWake-up latency.png "cyclictest_wake-up_latency Graph")

### ping_interval results

Ping RTT from A20 to shuttle, with fixed interval


**Common test metadata:** Device: A20, Linux kernel version: 5.6, Task priority: 98, Interval: 1000us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Test duration: 0h37, Speed (Mb/s): 1000, Packet route: E2E, Client device: A20, XDP: no

Minimum      | Maximum      | Average      | Standard deviation | Lost packets
------------ | ------------ | ------------ | ------------------ | ------------
**ping RTT** | **ping RTT** | **ping RTT** | **ping RTT**       |             
59.0000us    | 460.0000us   | 272.0000us   | 74.0000us          | 0           

![alt text](measures/graphs/ping_intervalping RTT.png "ping_interval Graph")

### shuttle_a20_signal_jitter results

Two A20 boards are connected end to end with an ethernet cable to a shuttle. All devices are synchronized with PTP. The shuttle sends packets containing timestamps to the boards, and the boards emit a signal at the given timestamp. A logic analyzer measures the variation difference between the signals of the two boards.

**Common test metadata:** Device: A20, Linux kernel version: 5.6, Task priority: 98, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, ETF offset: 500us, Packet route: E2E, qdisc: pfifo_fast

Metadata                                     | Minimum                         | Maximum                         | Average                         | Standard deviation              | Lost packets
-------------------------------------------- | ------------------------------- | ------------------------------- | ------------------------------- | ------------------------------- | ------------
**i, duration, delay, XDP**                  | **edge jitter - period jitter** | **edge jitter - period jitter** | **edge jitter - period jitter** | **edge jitter - period jitter** |             
1000us, 9h59, 600us, no (35999280, 71998560) | 0.0000us - 958.0000us           | 129.0000us - 1063.0000us        | 7.5260us - 999.5439us           | 9.5594us - 1.7508us             | 0           
500us, 13h59, 400us, no (100798095, 201596190) | 0.0000us - 360.0000us           | 265.0000us - 582.0000us         | 10.5889us - 499.5328us          | 9.7824us - 1.3678us             | 0           
500us, 14h59, 350us, yes (107997764, 215995528) | 0.0000us - 443.0000us           | 101.0000us - 558.0000us         | 9.4011us - 499.5338us           | 8.1783us - 1.0773us             | 0           
300us, 1h13, 250us, yes (14799547, 29599094) | 0.0000us - 251.0000us           | 84.0000us - 352.0000us          | 8.3746us - 299.5280us           | 6.8528us - 2.0352us             | 0           

![alt text](measures/graphs/shuttle_a20_signal_jitteredge jitter.png "shuttle_a20_signal_jitter Graph")

![alt text](measures/graphs/shuttle_a20_signal_jitterperiod jitter.png "shuttle_a20_signal_jitter Graph")

### packet_jitter results

An UDP packet is periodically sent from one board to another using a real time thread. The receiving board calculates the intervals between the packets it receives, and sees how much it differs from the scheduled interval.

**Common test metadata:** Device: A20, Linux kernel version: 5.6, Task priority: 98, Interval: 500us, Boot Parameters: isolcpus,rcu_nocbs,irqaffinity, ETF qdisc delta: None, Device and processor load: None, Speed (Mb/s): 1000, ETF offset: 500us, Packet route: E2E, qdisc: pfifo_fast, Client device: A20, Callback delay: none

Metadata           | Minimum           | Maximum           | Average           | Standard deviation | Lost packets
------------------ | ----------------- | ----------------- | ----------------- | ------------------ | ------------
**duration, XDP**  | **Packet jitter** | **Packet jitter** | **Packet jitter** | **Packet jitter**  |             
0h21, no (2638601) | 0.0000us          | 257.0000us        | 114.5039us        | 4.0028us           | 0           
0h22, no (2642534) | 0.0000us          | 272.0000us        | 115.5060us        | 7.2893us           | 0           
0h30, yes (3602864) | 0.0000us          | 176.0000us        | 79.5038us         | 2.2816us           | 0           
0h30, yes (3606075) | 0.0000us          | 234.0000us        | 106.5055us        | 8.3133us           | 0           

![alt text](measures/graphs/packet_jitterPacket jitter.png "packet_jitter Graph")


## Additional measures

## Packet transmission latency

### Shuttle to A20

#### Measures done with tracing and timestamps (some overhead):

**Without XDP:**

| **Latency measured**                   | **min** | **avg** | **max** |
| -------------------------------------- | ------- | ------- | ------- |
| IRQ -> RX SO_TIMESTAMP                 |   27us  |   31us  |  136us  |
| RX SO_TIMESTAMP -> Userspace timestamp |   85us  |   93us  |  247us  |
| IRQ -> Userspace timestamp             |  112us  |  124us  |  383us  |

**With XDP:**

IRQ -> XDP_REDIRECT : ~30us (more measures needs to be done)

#### Measures done with timestamps (little overhead):

| **Latency measured**                   |        | **Duration** | **Packets number** | **Interval** | **min** | **avg** |  **max** |  
| -------------------------------------- | ------ | ------------ | ------------------ | ------------ | ------- | ------  | ------   |  
| Shuttle timestamp -> A20 timestamp     | XDP    |  2h45        | 50 100 000         | 250us        |   22us  |   24us  |  173us   |
| Shuttle timestamp -> A20 timestamp     | no XDP |              |                    |              |   88us  |   88us  |  300us   |
| RX SO_TIMESTAMP (A20)                  | no XDP |              |                    |              |   67us  |  172us  |  173us   |
| TX SO_TIMESTAMP -> (Shuttle)           | no XDP |              |                    |              |    2us  |   18us  |   20us   |

