#ifndef SEND_PACKET_H
#define SEND_PACKET_H

#include "common.h"

typedef struct egress_param {
  int packet_priority;
  size_t tx_buffer_len;
  char server_ip[45];
  char network_if[16];

  int use_etf;
  int use_timestamps;

} egress_param_t;

typedef struct egress_stat {

  uint64_t high_kernel_latency;
  uint64_t invalid_parameter;
  uint64_t missed_deadline;

  int min_kernel_latency;
  int avg_kernel_latency;
  int max_kernel_latency;

  int min_interval;
  int avg_interval;
  int max_interval;

} egress_stat_t;

void init_udp_send(egress_param_t *_params,
                   egress_stat_t *_stats,
                   int _use_histogram, int _stop_tracing, int _send_ts, int log_timestamps,
                   uint64_t *_kernel_latency_hist);

void send_udp_packet(char *data, uint64_t txtime);

#endif
